subtle - Bug #318

Stack smashing when loading a sublet
02/02/2018 01:51 PM - Christoph Kappel

Status: Fixed Start date: 02/02/2018
Priority: Normal Due date:

Assignee: Christoph Kappel % Done: 0%
Category: Bugfix Estimated time: 0.00 hour
Target version: Omicron

Description

When subtle is compiled with -D_FORTIFY_SOURCE=2 subtle crashes, when the first sublet is loaded:

Reading file " /home/unexist/.local/share/subtle/sublets/clock.rb'

*** gtack smashing detected ***:
======= Backtrace: =======

./subtle terminated

/1ib/x86_64-1linux—gnu/libc.so.6 (+0x70bcb) [0x7f6febd48bcb]
/1lib/x86_64-linux—gnu/libc.so.6(__fortify_ fail+0x37) [0x7f6febddl227]
/1ib/x86_64-linux—gnu/libc.so.6(__ _fortify fail+0x0) [0x7f6febddl11£f0]
./subtle (+0x68c7) [0x55d220028c7]
./subtle (+0x271bb) [0x55bd220231bb]
./subtle (+0x20c0e) [0x55bd2201ccle]

/home/unexist/.rvm/rubies/ruby-2.5.0/1ib/libruby.so.
/home/unexist/.rvm/rubies/ruby-2.
/home/unexist/.rvm/rubies/ruby-2.
/home/unexist/.rvm/rubies/ruby-2.
/home/unexist/.rvm/rubies/ruby-2.
/home/unexist/.rvm/rubies/ruby-2.
/home/unexist/.rvm/rubies/ruby-2.
/home/unexist/.rvm/rubies/ruby-2.
/home/unexist/.rvm/rubies/ruby-2.
/home/unexist/.rvm/rubies/ruby-2.5.0/1ib/libruby.so.

[S2NE INE, BNE, NG, BN B, BN,

./subtle (+0x1c210) [0x55bd22018210]

/home/unexist/.rvm/rubies/ruby-2.5

./subtle (+0x22dca) [0x55bd2201ledca]
./subtle (+0x22766) [0x55bd2201e766]
./subtle (+0x22c88) [0x55bd2201ec88]
./subtle (+0x268b6) [0x55bd220228b6]
/1lib/x86_64-1linux—gnu/libc.so.6(__libc_start_main+0xfl) [0x7f6feb3£f82bl]
./subtle (+0x600a) [0x550bd2200200a]

=S Memory map: ======

.0/1ib/libruby.so.
.0/1lib/libruby.so.
.0/1lib/libruby.so.
.0/1lib/libruby.so.
.0/1lib/libruby.so.
.0/1lib/libruby.so.
.0/1lib/libruby.so.
.0/1ib/libruby.so.

55bd21££fc000-55bd2202a000 r-xp 00000000 fe:01

btle/subtle
55bd22229000-55bd2222a000
btle/subtle
55bd2222a000-55bd2222b000
btle/subtle
55bd2222b000-55bd2222c000
55bd23a6b000-55bd23£8d000
7f6fe86e6000-7f6£fe86£c000
gcc_s.so.1l
7£f6£fe86£c000-7£6£e88£fb000
gcc_s.so.1l
7f6fe88fb000-7£6£fe88£c000
gcc_s.so.1l
7f6fe88fc000-7f6fe88£d000
gcc_s.so.1l
7f6£e8912000-7£6£e8928000
e R.ttf
7£6£e8928000-7£6£e8939000
/libXpm.so0.4.11.0
7f6fe8939000-7£f6fe8b38000
/libXpm.so0.4.11.0
.5 (+0x210cef)

.5 (+0x223ad3)

.5(+0x21c069)

.5(+0x2205a0)

.5 (+0x220e44) [0x7f6fechaaedd]
.5(+0x2210£9)

.5 (+0x221474)

.5(+0x22526b)

.5 (+0x2259f6) [0x7f6fec5af9fo6]
.5(rb_funcall+0x10c) [0x7f6fec5b0l6c]

[Ox7f6fech99acef]
[Ox7f6fechadad3]
[0x7f6fec5a6069]
[0x7f6fec5aab5al]
[0x7f6fec5ab0£f9]

[Ox7f6fecbab4d74]
[0x7f6fec5af26b]

5 (rb_protect+0x125) [0x7f6fecd43deb55]

/home/unexist/projects/su
/home/unexist/projects/su
/home/unexist/projects/su
[heap]

/1ib/x86_64-1linux-gnu/lib
/1ib/x86_64-1linux—-gnu/lib
/1ib/x86_64-1linux—gnu/lib
/1ib/x86_64-1linux—-gnu/lib
/usr/share/fonts/Envy Cod
/usr/1ib/x86_64-1linux—gnu

/usr/1lib/x86_64-1linux—gnu
7£6£e8b38000-7£6£e8b39000 r——p 00010000 fe:01 3025597
/libXpm.so0.4.11.0

7£f6£e8b39000-7£6£fe8b3a000 rw-p 00011000 fe:01 3025597
/libXpm.so0.4.11.0

7£6£fe8b3a000-7£6fe8b62000 r—-xp 00000000 fe:01 24779231
btle/subtlext.so

7£6£e8b62000-7£6£fe8d62000 ——-p 00028000 fe:01 24779231
btle/subtlext.so

7£6£e8d62000-7£6£fe8d63000 r——p 00028000 fe:01 24779231
btle/subtlext.so

7£f6£e8d63000-7£6£e8d64000 rw-p 00029000 fe:01 24779231
btle/subtlext.so

7£6£e8d64000-7£6fe8d66000 r—-xp 00000000 fe:01 25954251
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/io/wait.so
7£6£e8d66000-7£6£fe8£65000 ———p 00002000 fe:01 25954251
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/io/wait.so
7£f6£fe8£65000-7£6fe8£66000 r——p 00001000 fe:01 25954251
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1linux/io/wait.so
7f6£fe8£66000-7£6£fe8£67000 rw-p 00002000 fe:01 25954251
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/io/wait.so
7£6£fe8£f67000-7£6£fe8£93000 r-xp 00000000 fe:01 25954243
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/socket.so
7£6£e8£93000-7£6£fe9192000 ——-p 0002c000 fe:01 25954243
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/socket.so
7£6£e9192000-7£6£e9193000 r——p 0002b000 fe:01 25954243
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/socket.so
7£f6£e9193000-7£6£e9194000 rw-p 0002c000 fe:01 25954243
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/socket.so
7£6£e9194000-7£6£fe919c000 r-xp 00000000 fe:01 25954247
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1linux/stringio.so
7£6£e919c000-7£6£fe939c000 ——-p 00008000 fe:01 25954247
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/stringio.so
7£6£e939c000-7£6£e939d000 r——p 00008000 fe:01 25954247
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/stringio.so
7£6£e939d000-7£6£e939e000 rw-p 00009000 fe:01 25954247
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/stringio.so
7£6£e939e000-7£6£fe93a1000 r-xp 00000000 fe:01 25954286

/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1linux/enc/trans/transdb.

7£6£fe93al000-7£6£e95a0000 —--p 00003000 fe:01 25954286

/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1linux/enc/trans/transdb.

7£6£e95a0000-7£6£e95a1000 r——p 00002000 fe:01 25954286

/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1linux/enc/trans/transdb.

7£6£fe95a1000-7£6£e95a2000 rw-p 00003000 fe:01 25954286

/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1linux/enc/trans/transdb.

7f6fe95a2000-7£f6fe95a4000 r-xp 00000000 fe:01 25954306
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/enc/encdb.so
7f6£fe95a4000-7£6fe97a3000 ———p 00002000 fe:01 25954306
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/enc/encdb.so
7£6£e97a3000-7£6£fe97a4000 r——p 00001000 fe:01 25954306
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/enc/encdb.so
7f6£fe97a4000-7£6£e97a5000 rw-p 00002000 fe:01 25954306
/ruby-2.5.0/1ib/ruby/2.5.0/x86_64-1inux/enc/encdb.so
7f6fe97a5000-7£f6fe98a6000 rw—p 00000000 00:00 O
7f6fe98a6000-7f6fe98ab000 r—-xp 00000000 fe:01 3027565
/libXfixes.so.3.1.0

7f6£fe98ab000-7f6fe%9aaa000 —--p 00005000 fe:01 3027565
/libXfixes.so0.3.1.0

7f6fe%9aaal000-7£6£fe%9aab000 r—--p 00004000 fe:01 3027565
/libXfixes.so0.3.1.0

7£f6fe%9aab000-7f6fe%9aac000 rw-p 00005000 fe:01 3027565
/libXfixes.so0.3.1.0

7f6fe%9aac000-7f6fe%9ab6000 r—-xp 00000000 fe:01 3027601
/libXcursor.so.1.0.2

7f6£fe9ab6000-7£6fe9cb5000 ——-p 0000a000 fe:01 3027601
/libXcursor.so.1.0.2

7f6fe9cb5000-7£6£fe9cb6000 r——-p 00009000 fe:01 3027601
/libXcursor.so.1.0.2
7£6fe9cb6000-7£6£fe9cb7000
/libXcursor.so.1.0.2
7£6£fe9cb7000-7f6fe9cbe000
rt-2.24.so0
7£6£fe9cbe000-7£6£fe9ebd000
rt-2.24.s0
7f6£fe9ebd000-7£f6fe9%ebe000
rt-2.24.s0
7f6fe%9ebe000-7£6fe9ebf000
rt-2.24.so
7f6fe9ebf000-7f6fe9ed2000
bsd.so0.0.8.3
7f6fe%9ed2000-7f6fea0d2000
bsd.so0.0.8.3
7f6£fea0d2000-7£6£ea0d3000
bsd.so0.0.8.3
7f6fea0d3000-7£6£fea0d4000
bsd.so0.0.8.3
7f6fea0d4000-7f6fea0d5000
7£6£fea0d5000-7f6fea0fc000
expat.so.1.6.2
7£f6feal0fc000-7f6fea2fc000
expat.so.1.6.2
7f6fea2fc000-7f6fea2£e000
expat.so.1.6.2
7f6fea2fe000-7f6fea2f£000
expat.so.1.6.2
7f6fea2ff000-7f6fea304000
/1libXdmcp.s0.6.0.0
7f6£fea304000-7£f6£fea503000
/1libXdmcp.s0.6.0.0
7f6£ea503000-7£6£ea504000
/1libXdmcp.so0.6.0.0
7£f6£fea504000-7f6fea505000
/1libXdmcp.s0.6.0.0
7f6fea505000-7f6fea508000
/libXau.s0.6.0.0
7f6fea508000-7f6fea707000
/libXau.s0.6.0.0
7f6£fea707000-7£6£ea708000
/libXau.s0.6.0.0
7f6fea708000-7£f6£fea709000
/libXau.s0.6.0.0
7£6£fea709000-7f6fea71a000
/libXext.s0.6.4.0
7f6fea71a000-7£6£ea919000
/libXext.s0.6.4.0
7£f6£ea919000-7£f6£fea91a000
/libXext.s0.6.4.0
7f6fea91a000-7f6fea91b000
/libXext.s0.6.4.0
7f6fea91b000-7f6fea924000
/libXrender.so.1.3.0
7f6£fea924000-7f6feab23000
/libXrender.so.1.3.0
7f6feab23000-7£f6feab24000
/libXrender.so.1.3.0
7f6feab24000-7f6feab25000
/libXrender.so.1.3.0
7£f6feab25000-7f6feab61000
/libfontconfig.so.1.8.0
7f6feab61000-7f6feado60000
/libfontconfig.so.1.8.0
7f6fead60000-7£f6fead62000
/libfontconfig.so0.1.8.0
7f6fead62000-7f6fead63000
/libfontconfig.s0.1.8.0
7f6fead63000-7£f6£fead94000
/1libpngl6.s0.16.28.0
7f6fead94000-7f6feaf94000
/1libpngl6.s50.16.28.0
7f6feaf94000-7f6feaf95000
/1libpngl6.50.16.28.0
7f6£feaf95000-7f6feaf96000
/1libpngl6.50.16.28.0
T7f6feaf96000-7f6feafaf000
z.s0.1.2.8
7f6feafaf000-7f6feblae000
z.s50.1.2.8
7f6feblae000-7f6feblaf000
z.s0.1.2.8
7f6feblaf000-7f6feblb0000
z.s0.1.2.8
7£6£feblb0000-7£f6£febl1d7000
/libxcb.so.1.1.0
7f6febld7000-7f6feb3d6000
/libxcb.so.1.1.0
7f6feb3d6000-7f6feb3d7000
/libxcb.so.1.1.0
7f6£feb3d7000-7£6£feb3d8000
/libxcb.so.1.1.0
7£6£feb3d8000-7£f6feb56d000
c-2.24.s0
7f6feb56d000-7f6feb76d000
c-2.24.s0
T7f6feb76d000-7£f6feb771000
c-2.24.s0
7f6£feb771000-7f6feb773000
c-2.24.s0
T7£6£feb773000-7£6£feb777000
7£f6feb777000-7f6feb781000
/libXrandr.so.2.2.0
7f6feb781000-7f6feb980000
/libXrandr.so.2.2.0
7f6£feb980000-7f6feb981000
/libXrandr.so.2.2.0
7f6£eb981000-7£6£feb982000
/libXrandr.so0.2.2.0
7f6£feb982000-7£6£feb984000
/libXinerama.so.1.0.0
7f6£feb984000-7f6febb83000
/libXinerama.so.1.0.0
7f6£febb83000-7f6febb84000
/libXinerama.so.1.0.0
7f6£febb84000-7£6febb85000
/libXinerama.so.1.0.0
7£6febb85000-7f6febb9a000
/1libXft.s0.2.3.2
7f6febb9a000-7f6febd99000
/1libXft.s0.2.3.2
7f6£febd99000-7f6febd9a000
/1libXft.s0.2.3.2
7f6£febd9a000-7£6febd9b000
/libXft.s0.2.3.2
7£6febd9b000-7f6febed3000
/libfreetype.s0.6.12.3
7f6febed3000-7f6fec043000
/libfreetype.so.6.12.3
7f6£fec043000-7£6fec049000
/libfreetype.so.6.12.3
7f6£fec049000-7£f6fec04a000
/libfreetype.so.6.12.3
7f6fec04a000-7f6fec184000
/1ibX11.s0.6.3.0
7f6fecl184000-7£6£fec384000 -—-p
/1ibX11l.s50.6.3.0
7£f6£fec384000-7£6£fec385000 r--p
/1ibX11l.s50.6.3.0
7£f6fec385000-7£6fec38a000 rw-p
/1ibX11.50.6.3.0
7£6fec38a000-7£6£fec690000 r—-xp

/ruby-2.5.0/1ib/libruby.so0.2.5.

7£6£fec69b000-7£6£ec890000 —-—-p

/ruby-2.5.0/1ib/libruby.so0.2.5.

7£f6£fec89b000-7£6fec8a0000 r--p

/ruby-2.5.0/1ib/libruby.so0.2.5.

7f6fec8a0000-7£6fec8a3000 rw-p

/ruby-2.5.0/1ib/libruby.so0.2.5.

7£6fec8a3000-7£6£fec8b4000 rw-p
7£6£fec8b4000-7£6£fec9p7000 r-xp
m-2.24.s0
7£6fec9b7000-7£6fecbb6000 -—--p
m-2.24.s0
7£f6fecbb6000-7f6fecbb7000 r——p
m-2.24.s0
7£6fecbb7000-7£6fecbb8000 rw-p
m-2.24.s0
7£6fecbb8000-7£6fecbc0000 r—-xp
crypt—-2.24.so0
7f6fecbc0000-7£f6fecdc0000 ---p
crypt-2.24.so0
7£f6fecdc0000-7f6fecdcl000 r——p
crypt-2.24.s0
7f6fecdcl000-7£f6fecdc2000 rw-p
crypt-2.24.s0
7£f6fecdc2000-7£6£fecdf0000 rw-p
7f6fecdf0000-7£6fecdf3000 r—-xp
dl-2.24.s0
7f6fecdf3000-7f6fecf£f2000 ---p
dl-2.24.s0
7£f6fecff2000-7f6fecf£f3000 r——p
dl-2.24.so0
7£6fecff3000-7£6£fecf£f4000 rw-p
dl-2.24.so
7f6fecff4000-7£6£ed075000 r—-xp
/libgmp.so.10.3.2
7f6£fed075000-7£6£ed275000 —--p
/libgmp.so0.10.3.2
7f6£fed275000-7£6£ed276000 r--p
/libgmp.s0.10.3.2
7£6£fed276000-7£6£ed277000 rw-p
/libgmp.s0.10.3.2
7f6£ed277000-7£6£fed28£000 r—-xp
pthread-2.24.s0
7f6£fed28f000-7£6£fed48e000 ——--p
pthread-2.24.so0
7£6£fed48e000-7£6£fed48£f000 r——p
pthread-2.24.s0
7f6£fed48£f000-7£6£ed490000 rw-p
pthread-2.24.s0o
7f6£ed490000-7£6£fed494000 rw-p
7f6£ed494000-7£6fed4b7000 r—-xp
2.24.s0
7£6£fed4b9000-7f6fed4bal000 rw-p
7f6fed4bal000-7£6fed4c1000 r--s
History

#1 - 02/09/2018 01:05 PM - Christoph Kappel

- Description updated

#2 - 02/09/2018 01:06 PM - Christoph Kappel

- Description updated

#3 - 02/09/2018 01:44 PM - Christoph Kappel

- Description updated

#4 - 02/15/2018 09:15 AM - Christoph Kappel

- Status changed from Unconfirmed to Fixed
